{"title":"Create purchaseInvoiceLines","url":"https://jonas-paprotka.de/docs/dev-itpro/api-reference/v2.0/api/dynamics_purchaseinvoiceline_create/","by":"JOP-AL","license":"Copyright (c) Microsoft Corporation. CC BY 4.0, https://creativecommons.org/licenses/by/4.0/; code samples MIT. From https://learn.microsoft.com/en-us/dynamics365/business-central/dev-itpro/api-reference/v2.0/api/dynamics_purchaseinvoiceline_create, MicrosoftDocs/dynamics365smb-devitpro-pb at 828b6ee (2026-11-19). Changed: includes filled in, links to this site, and for agents shortened without dropping a fact.","credit":"Microsoft Corporation, CC BY 4.0","origin":"https://learn.microsoft.com/en-us/dynamics365/business-central/dev-itpro/api-reference/v2.0/api/dynamics_purchaseinvoiceline_create","source":{"name":"Business Central developer and IT pro docs","repo":"https://github.com/MicrosoftDocs/dynamics365smb-devitpro-pb","commit":"828b6ee72fcd75755627cd6011f3d20899217ab2","date":"2026-11-19"},"checked":"2026-11-19","description":"Creates a purchase invoice line object in Dynamics 365 Business Central.","date":"2026-08-21","meta":{"topic":"reference"},"outline":[{"level":2,"title":"HTTP request","slug":"http-request","at":59,"chars":301},{"level":2,"title":"Request headers","slug":"request-headers","at":360,"chars":102},{"level":2,"title":"Request body","slug":"request-body","at":462,"chars":100},{"level":2,"title":"Response","slug":"response","at":562,"chars":135},{"level":2,"title":"Example","slug":"example","at":697,"chars":2366},{"level":2,"title":"Create a new purchase invoice with a line by using deep insert","slug":"create-a-new-purchase-invoice-with-a-line-by-using-deep-insert","at":3063,"chars":988},{"level":2,"title":"Add multiple lines to an existing purchase invoice by using $batch","slug":"add-multiple-lines-to-an-existing-purchase-invoice-by-using-batch","at":4051,"chars":1631},{"level":2,"title":"Related information","slug":"related-information","at":5682,"chars":355}],"text":"Create a purchase invoice line object in Business Central.\n## HTTP request\nReplace the URL prefix for Business Central depending on environment following the guideline<../endpoints-apis-for-dynamics>.\n```\nPOST businesscentralPrefix/companies({id})/purchaseInvoices({id})/purchaseInvoiceLines\nPOST businesscentralPrefix/companies({id})/purchaseInvoiceLines\n```\n## Request headers\nHeader|Value\nAuthorization|Bearer {token}. Required.\nContent-Type|application/json\n## Request body\nIn the request body, supply a JSON representation of a purchaseInvoiceLines object.\n## Response\nIf successful, this method returns ```201 Created``` response code and a purchaseInvoiceLines object in the response body.\n## Example\nRequest\nHere's an example of a request.\n```json\nPOST https://{businesscentralPrefix}/api/v2.0/companies({id})/purchaseInvoices({id})/purchaseInvoiceLines\nContent-type: application/json\n\n{\n    \"id\": \"dd8db9c0-44e3-ea11-bb43-000d3a2feca1\",\n    \"documentId\": \"5d115c9c-44e3-ea11-bb43-000d3a2feca1\",\n    \"sequence\": 10000,\n    \"itemId\": \"fca5738a-44e3-ea11-bb43-000d3a2feca1\",\n    \"accountId\": \"00000000-0000-0000-0000-000000000000\",\n    \"lineType\": \"Item\",\n    \"lineObjectNumber\": \"1896-S\",\n    \"description\": \"ATHENS Desk\",\n    \"unitOfMeasureId\": \"5ca6738a-44e3-ea11-bb43-000d3a2feca1\",\n    \"unitOfMeasureCode\": \"PCS\",\n    \"unitCost\": 780.7,\n    \"quantity\": 4,\n    \"discountAmount\": 0,\n    \"discountPercent\": 0,\n    \"discountAppliedBeforeTax\": false,\n    \"amountExcludingTax\": 0,\n    \"taxCode\": \"FURNITURE\",\n    \"amountIncludingTax\": 0,\n    \"invoiceDiscountAllocation\": 0,\n    \"netAmount\": 3122.8,\n    \"netTaxAmount\": 187.37,\n    \"netAmountIncludingTax\": 3310.17,\n    \"expectedReceiptDate\": \"2019-01-01\",\n    \"itemVariantId\": \"00000000-0000-0000-0000-000000000000\",\n    \"locationId\": \"00000000-0000-0000-0000-000000000000\"\n}\n```\nResponse\nHere's an example of the response.\n> NOTE\n> The response object shown here may be truncated for brevity. All of the properties will be returned from an actual call.\n```json\nHTTP/1.1 201 Created\nContent-type: application/json\n\n{\n    \"id\": \"dd8db9c0-44e3-ea11-bb43-000d3a2feca1\",\n    \"documentId\": \"5d115c9c-44e3-ea11-bb43-000d3a2feca1\",\n    \"sequence\": 10000,\n    \"itemId\": \"fca5738a-44e3-ea11-bb43-000d3a2feca1\",\n    \"accountId\": \"00000000-0000-0000-0000-000000000000\",\n    \"lineType\": \"Item\",\n    \"lineObjectNumber\": \"1896-S\",\n    \"description\": \"ATHENS Desk\",\n    \"unitOfMeasureId\": \"5ca6738a-44e3-ea11-bb43-000d3a2feca1\",\n    \"unitOfMeasureCode\": \"PCS\",\n    \"unitCost\": 780.7,\n    \"quantity\": 4,\n    \"discountAmount\": 0,\n    \"discountPercent\": 0,\n    \"discountAppliedBeforeTax\": false,\n    \"amountExcludingTax\": 0,\n    \"taxCode\": \"FURNITURE\",\n    \"taxPercent\": 6.00006,\n    \"totalTaxAmount\": 0,\n    \"amountIncludingTax\": 0,\n    \"invoiceDiscountAllocation\": 0,\n    \"netAmount\": 3122.8,\n    \"netTaxAmount\": 187.37,\n    \"netAmountIncludingTax\": 3310.17,\n    \"expectedReceiptDate\": \"2019-01-01\",\n    \"itemVariantId\": \"00000000-0000-0000-0000-000000000000\",\n    \"locationId\": \"00000000-0000-0000-0000-000000000000\"\n}\n```\n## Create a new purchase invoice with a line by using deep insert\nIf you need to create a new purchase invoice together with one line, use a deep insert on dynamics_purchaseinvoice_create. Send the header fields and one nested purchaseInvoiceLines entry in one POST request.\nDeep insert and `$batch` are complementary:\n Use deep insert to create a new invoice and one line in one atomic request. No batch envelope is required.\n Use `$batch` to add multiple lines to an existing invoice or combine multiple operations in one transactional request.\nRequest\n```json\nPOST https://{businesscentralPrefix}/api/v2.0/companies({id})/purchaseInvoices\nContent-type: application/json\n\n{\n    \"vendorNumber\": \"20000\",\n    \"vendorInvoiceNumber\": \"107001\",\n    \"purchaseInvoiceLines\": [\n        {\n            \"lineType\": \"Item\",\n            \"lineObjectNumber\": \"1896-S\",\n            \"quantity\": 4\n        }\n    ]\n}\n```\nA successful request returns `201 Created` and the created purchaseInvoices object.\n## Add multiple lines to an existing purchase invoice by using $batch\nIf the purchase invoice already exists, use an OData transactional `$batch` request<../../../webservices/use-odata-batch> to add multiple lines in a single HTTP call. This pattern is also useful when you need one transactional request that combines different operations.\nRequest\n```json\nPOST https://{businesscentralPrefix}/api/v2.0/$batch\nContent-type: application/json\nIsolation: snapshot\n\n{\n    \"requests\": [\n        {\n            \"method\": \"POST\",\n            \"id\": \"1\",\n            \"url\": \"companies({id})/purchaseInvoices({purchaseInvoiceId})/purchaseInvoiceLines\",\n            \"headers\": {\n                \"Content-Type\": \"application/json\"\n            },\n            \"body\": {\n                \"lineType\": \"Item\",\n                \"lineObjectNumber\": \"1896-S\",\n                \"quantity\": 4,\n                \"expectedReceiptDate\": \"2024-04-15\"\n            }\n        },\n        {\n            \"method\": \"POST\",\n            \"id\": \"2\",\n            \"url\": \"companies({id})/purchaseInvoices({purchaseInvoiceId})/purchaseInvoiceLines\",\n            \"headers\": {\n                \"Content-Type\": \"application/json\"\n            },\n            \"body\": {\n                \"lineType\": \"Item\",\n                \"lineObjectNumber\": \"1900-S\",\n                \"quantity\": 10,\n                \"expectedReceiptDate\": \"2024-04-15\"\n            }\n        }\n    ]\n}\n```\n> TIP\n> The `Isolation: snapshot` header ensures that if any line fails validation, all changes in the batch are rolled back. See Using OData transactional $batch requests<../../../webservices/use-odata-batch>.\n## Related information\nTips for working with the APIs<../../../developer/devenv-connect-apps-tips>\nPurchase Invoice Line<../resources/dynamics_purchaseinvoiceline>\nGet Purchase Invoice Line<dynamics_purchaseinvoiceline_get>\nUpdate Purchase Invoice Line<dynamics_purchaseinvoiceline_update>\nDelete Purchase Invoice Line<dynamics_purchaseinvoiceline_delete>"}